{DESKS.PAS}
PROCEDURE KS(key: gl64array; n: integer; VAR kn: gl48array);
{Prpcedure generating 16 cryptographic keys. The values of ipc1
 and ipc2 are read from the file ksinpu.dat. The procedure GLOPEN
 assigns ksinpu.dat to infile and opens the file for reading.}
VAR
   j,it,id,ic,i: integer;
   infile: text;
BEGIN
  IF ksflg THEN BEGIN
      ksflg := false;
      GLOPEN(infile,'ksinpu.dat');
      FOR i := 1 to 56 DO read(infile,ipc1[i]);
      FOR i := 1 to 48 DO read(infile,ipc2[i]);
      close(infile)
   END;
   IF (n = 1) THEN BEGIN
      FOR j := 1 to 56 DO BEGIN
         glicd[j] := key[ipc1[j]]
      END
   END;
   it := 2;
   IF ((n = 1) OR (n = 2) OR (n = 9) OR (n = 16)) THEN it := 1;
   FOR i := 1 to it DO BEGIN
      ic := glicd[1];
      id := glicd[29];
      FOR j := 1 to 27 DO BEGIN
         glicd[j] := glicd[j+1];
         glicd[j+28] := glicd[j+29]
      END;
      glicd[28] := ic;
      glicd[56] := id
   END;
   FOR j := 1 to 48 DO kn[j] := glicd[ipc2[j]]
END;

PROCEDURE CYFUN(ir: gl32array; k: gl48array; VAR iout: gl32array);
{Procedure implementing ciphering function. The values of iet, ipp,
 is and ibin are read from the file cyfuni.dat. The procedure GLOPEN
 assigns cyfuni.dat to infile and opens the file for reading.}
VAR
   jj,irow,icol,kk,iss,ki,j: integer;
   ie: gl48array;
   itmp: gl32array;
   infile: text;
BEGIN
   IF cyflg THEN BEGIN
      cyflg := false;
      GLOPEN(infile,'cyfuni.dat');
      FOR j := 1 to 48 DO read(infile,iet[j]);
      FOR j := 1 to 32 DO read(infile,ipp[j]);
      FOR jj := 1 to 8 DO
         FOR ki := 1 to 4 DO
            FOR j := 1 to 16 DO read(infile,is[j,ki,jj]);
      FOR j := 1 to 16 DO
         FOR ki := 1 to 4 DO read(infile,ibin[ki,j]);
      close(infile)
   END;
   FOR j := 1 to 48 DO ie[j] := (((ir[iet[j]]+k[j]) MOD 2)+2) MOD 2;
   FOR jj := 1 to 8 DO BEGIN
      j := 6*jj-5;
      irow := 2*ie[j]+ie[j+5];
      icol := 8*ie[j+1]+4*ie[j+2]+2*ie[j+3]+ie[j+4];
      iss := is[icol+1,irow+1,jj];
      kk := 4*(jj-1);
      FOR ki := 1 to 4 DO itmp[kk+ki] := ibin[ki,iss+1]
   END;
   FOR j := 1 to 32 DO iout[j] := itmp[ipp[j]]
END;
